#
# spec file for package perl (Version 5.8.1)
#
# Copyright (c) 2005 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org
#

# neededforbuild  db-devel
# usedforbuild    aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libstdc++ libxcrypt m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-devel pam-modules patch permissions popt ps rcs readline sed sendmail shadow strace syslogd sysvinit tar texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils cracklib db-devel gcc gdbm gettext libtool perl rpm

Name:         perl
License:      GPL, Artistic License
Group:        Development/Languages/Perl
Provides:     perl-500 perl-base perl-Digest perl-Digest-MD5 perl-Filter-Simple perl-I18N-LangTags perl-MIME-Base64 perl-Storable perl-Test-Simple perl-Text-Balanced perl-Time-HiRes perl-libnet
Obsoletes:    perl-Digest perl-Digest-MD5 perl-Filter-Simple perl-I18N-LangTags perl-MIME-Base64 perl-Storable perl-Test-Simple perl-Text-Balanced perl-Time-HiRes perl-libnet
PreReq:       %fillup_prereq
Autoreqprov:  on
Version:      5.8.1
Release:      133
Summary:      The Perl interpreter
Source:       perl-%{version}.tar.bz2
Patch:        perl-%{version}.dif
Patch1:       perl-can-2005-0155.dif
Patch2:       perl-can-2005-0156.dif
Patch3:       perl-can-2004-0452.dif
Patch4:       perl-sprintf.dif
Patch5:       perl-syslog.dif
BuildRoot:    %{_tmppath}/%{name}-%{version}-build

%description
perl - Practical Extraction and Report Language

Perl is optimized for scanning arbitrary text files, extracting
information from those text files, and printing reports based on that
information.  It is also good for many system management tasks. Perl is
intended to be practical (easy to use, efficient, and complete) rather
than beautiful (tiny, elegant, and minimal).

Some of the modules available on CPAN can be found in the "perl"
series.

Attention: due to security reasons we have disabled the suid bit of
/usr/bin/suidperl.  If you need this feature, please add the following
line to /etc/permissions.local and run SuSEconfig.

/usr/bin/suidperl	root.root	 4755



Authors:
--------
    Larry Wall, Louis J. LaBash, Jr. <llabash@siue.edu>

%prep
%setup -n perl-5.8.1
%patch
%patch1
%patch2
%patch3
%patch4 -p1
%patch5

%build
optimize="-Doptimize='$RPM_OPT_FLAGS -Wall -pipe'"
%ifarch alpha
# -mieee needed for bad alpha gcc optimization
optimize="-Doptimize='$RPM_OPT_FLAGS -Wall -pipe -mieee'"
%endif
chmod 755 ./configure.gnu
./configure.gnu --prefix=/usr -Dvendorprefix=/usr -Dinstallusrbinperl -Dusethreads -Di_db -Di_dbm -Di_ndbm -Di_gdbm -Duseshrplib=\'true\' $optimize
make
mv libperl.so savelibperl.so
mv lib/Config.pm saveConfig.pm
mv lib/auto/DynaLoader/DynaLoader.a saveDynaLoader
make clobber
./configure.gnu --prefix=/usr -Dvendorprefix=/usr -Dinstallusrbinperl -Dusethreads -Di_db -Di_dbm -Di_ndbm -Di_gdbm $optimize
make
%ifnarch ppc64 armv4l
# delete broken File::Find test
rm -f lib/File/Find/t/find.t
make test
%endif

%install
make install DESTDIR=$RPM_BUILD_ROOT
cp -a $RPM_BUILD_ROOT/usr/lib/perl5/site_perl $RPM_BUILD_ROOT/usr/lib/perl5/vendor_perl
cpa=`echo $RPM_BUILD_ROOT/usr/lib/perl5/*/*/CORE | sed -e 's@/CORE$@@'`
cp=`echo "$cpa" | sed -e 's@/[^/]*$@@'`
vpa=`echo $cpa | sed -e 's@/perl5/@/perl5/vendor_perl/@'`
vp=`echo "$vpa" | sed -e 's@/[^/]*$@@'`
install -d $vp/auto
install -d $vpa/auto
install -m 555 savelibperl.so $cpa/CORE/libperl.so
install -m 444 saveConfig.pm $cpa/Config.pm
install -m 444 saveDynaLoader $cpa/auto/DynaLoader/DynaLoader.a
install -d $RPM_BUILD_ROOT/var/adm/SuSEconfig/bin
install -d $RPM_BUILD_ROOT/sbin/conf.d
install -d $RPM_BUILD_ROOT/var/adm/fillup-templates
install -m 755 SuSE/perllocal.SuSE $RPM_BUILD_ROOT/var/adm/SuSEconfig/bin
install -m 755 SuSE/SuSEconfig.perl $RPM_BUILD_ROOT/sbin/conf.d
install -m 755 SuSE/sysconfig.suseconfig-perl $RPM_BUILD_ROOT/var/adm/fillup-templates
for d in . sys linux asm* bits gnu net netinet db4 rpc arpa; do
( cd /usr/include
  for f in $d/*.h ; do test "$f" != "$d/*.h" && $RPM_BUILD_ROOT/usr/bin/perl -I$cp -I$cpa $RPM_BUILD_ROOT/usr/bin/h2ph -d $vpa $f || : ; done
)
done
d="`gcc -print-file-name=include`"
test -f "$d/stdarg.h" && (cd $d ; $RPM_BUILD_ROOT/usr/bin/perl -I$cp -I$cpa $RPM_BUILD_ROOT/usr/bin/h2ph -d $vpa stdarg.h stddef.h float.h)
chmod 755 $RPM_BUILD_ROOT/usr/bin/suidperl

%post
%{fillup_only -an suseconfig}

%preun
PERLLOCAL_PATH=`perl -V:installarchlib | sed -e "s/.*='\/\(.*\)'.*/\1/"`
rm -f usr/share/man/man3/perllocal.3pm.gz "$PERLLOCAL_PATH/perllocal.pod"

%files
/sbin/conf.d/SuSEconfig.perl
/var/adm/SuSEconfig/bin/perllocal.SuSE
/var/adm/fillup-templates/sysconfig.suseconfig-perl
/usr/bin/*
/usr/lib/perl*
%doc /usr/share/man/man1/*
%doc /usr/share/man/man3/*

%changelog -n perl
* Fri Dec 16 2005 - mls@suse.de
- add another sprintf fix (#136360)
* Fri Dec 09 2005 - mls@suse.de
- fix sprintf format string issues CVE-2005-3962 (#136360)
* Fri Feb 04 2005 - mls@suse.de
- fix CAN-2005-0155/CAN-2005-0156 (PERLIO_DEBUG)
- fix CAN-2004-0452 (File::Path::rmtree)
* Mon Dec 08 2003 - mls@suse.de
- fix setenv issue by making perl behave differently if embedded
  in an application (turns on PERL_USE_SAFE_PUTENV) [#32548]
* Mon Oct 06 2003 - mls@suse.de
- update to perl-5.8.1
- fix srand initialization problem [perl change #21397]
* Mon Sep 22 2003 - mls@suse.de
- update to perl-5.8.1-RC5
* Fri Aug 22 2003 - mls@suse.de
- update to perl-5.8.1-RC4
- added sysconfig metadata
- use /usr/lib/perl* in the filelist so /usr/lib/debug doesn't get
  picked up
* Thu Aug 21 2003 - mjancar@suse.cz
- use $RPM_OPT_FLAGS
* Fri Aug 01 2003 - mls@suse.de
- fixed perlcc
* Thu Jul 31 2003 - mls@suse.de
- update to perl-5.8.1-RC3
* Mon Jul 14 2003 - mls@suse.de
- MM_Unix: fix vendor/siteman default path
* Fri Jul 11 2003 - mls@suse.de
- create auto dirs in vendor_perl
* Fri Jul 11 2003 - mls@suse.de
- update to perl-5.8.1-RC2
- use buildroot
* Wed Jun 11 2003 - kukuk@suse.de
- Add auto subdirectory for perl modules
* Fri May 09 2003 - ro@suse.de
- fix build with db-4.1
* Thu Feb 06 2003 - mls@suse.de
- add sysconfig metadata to sysconfig.suseconfig-perl
- fix memory leak in socket creation
- restart stdio read/write when receiving EINTR
* Thu Jan 09 2003 - mls@suse.de
- link with -lgdbm_compat when building ODBM_File
* Tue Sep 17 2002 - ro@suse.de
- get all ph-files for bi-arch platforms
* Tue Sep 17 2002 - mls@suse.de
- work around a bug in .ph file generation (#19664)
* Mon Sep 09 2002 - mls@suse.de
- fix permissions of libperl.so
- added missing enc2xs binary
- create more .ph header files
- fixed h2ph enum handling
- (fixes bug #19175)
* Fri Aug 23 2002 - mls@suse.de
- Fix bug in conversion of literals to floating point
- Add workaround for glibc crypt_r() bug
* Fri Aug 09 2002 - mls@suse.de
- fix libs to include pthreads if threads are selected and
  /lib64/libc.so.6 exists
* Thu Aug 08 2002 - mls@suse.de
- enabled thread support
* Wed Aug 07 2002 - mls@suse.de
- corrected file list, added obsolete entries also to provides
* Wed Jul 31 2002 - mls@suse.de
- Added Obsoletes line to obsolete all modules now packed
  with the core perl
* Fri Jul 26 2002 - kukuk@suse.de
- Add a Provide "perl-base" [Bug #17259]
* Tue Jul 23 2002 - mls@suse.de
- Allow missing tests in 'make test'
- delete broken lib/File/Find/t/find.t test
* Tue Jul 23 2002 - mls@suse.de
- MM_Unix.pm: use INSTALLARCHLIB instead of INSTALLSITEARCH to
  store the site perllocal.pod file, like the printed message says
- added missing man3 pages
* Mon Jul 22 2002 - mls@suse.de
- MM_Unix.pm: allow to overwrite PREFIX in the makefile, use
  better default for installsiteman{1,3}dir
* Fri Jul 19 2002 - mls@suse.de
- update to perl-5.8.0
* Fri Jul 05 2002 - kukuk@suse.de
- Use %%ix86 macro
* Tue Jun 18 2002 - uli@suse.de
- disable check on armv4l
* Mon Jun 10 2002 - mls@suse.de
- Pod::Man: don't put the generation date in the man pages
* Thu Jun 06 2002 - olh@suse.de
- disable make check on ppc64, enable lfs test on ppc
* Thu Mar 14 2002 - mls@suse.de
- Allow XSUBs as AUTOLOAD functions, worked in 5.6.0, needed
  for perl-Qt
* Fri Feb 22 2002 - mls@suse.de
- Fixed File::Find if no_chdir is set (Ticket 20020213990000277)
* Wed Feb 20 2002 - mls@suse.de
- Build DynaLoader.a with -fPIC to make mod_perl work on s390x
* Wed Feb 06 2002 - coolo@suse.de
- patch Configure to also use -fPIC on Linux - prevents crashes on
  s390x
- ported over the hints patch from 7.2-lib64
* Tue Feb 05 2002 - mls@suse.de
- Use Config.pm of libperl.so build, so that apps use the right
  link options.
* Mon Feb 04 2002 - mls@suse.de
- Added generation of libperl.so
* Thu Jan 24 2002 - schwab@suse.de
- Fix h2ph for gcc 3.
* Mon Jan 14 2002 - mls@suse.de
- Moved rc.config variable to sysconfig/suseconfig
* Mon Jan 07 2002 - schwab@suse.de
- Fix dependency generation for gcc 3.1 again.
* Thu Dec 06 2001 - schwab@suse.de
- Don't add /usr/local/lib and /usr/local/include to the search paths.
- Fix dependency generation for gcc 3.1.
* Tue Nov 20 2001 - schwab@suse.de
- Don't generate h2ph, h2xs, pod2man manpages by hand.
* Thu Sep 27 2001 - mls@suse.de
- Fixed generation of perllocal.pod, also create perllocal.3pm
* Wed Sep 12 2001 - mls@suse.de
- Fixed h2ph macro expansion/redefinition bugs.
- Moved *.ph creation from SuSEconfig to spec file.
* Fri Aug 31 2001 - schwab@suse.de
- Remove ia64 workarounds.
* Wed Jun 20 2001 - mls@suse.de
- bzip2 source
* Wed Jun 20 2001 - mls@suse.de
- Update to perl-5.6.1
- Merged linux-alpha.sh and linux-sparc.sh into linux.sh
- axp compiler workaround: add -mieee
- use /lib64:/usr/lib64 on sparc64
* Mon Jun 11 2001 - schwab@suse.de
- Remove ElectricFence from neededforbuild (got added by accident).
* Fri Apr 13 2001 - schwab@suse.de
- Build with -O0 on ia64.
* Mon Mar 26 2001 - schwab@suse.de
- Fix equality operator for systems that don't have NV_PRESERVES_UV.
- Reenable some tests on ia64.
* Thu Feb 22 2001 - schwab@suse.de
- Fix POSIX module.
* Tue Dec 05 2000 - schwab@suse.de
- Disable some problematic tests on ia64.
- Merge ia64 configuration with generic linux.
* Thu Oct 26 2000 - ro@suse.de
- use new db for DB_File
- perl binary is no longer linked to any db lib
* Tue Oct 10 2000 - ro@suse.de
- Config.pm: set $perl to 'perl'
- bzipped sources
- added some mandir patches
* Mon Sep 25 2000 - ro@suse.de
- no test for lfs on ppc
* Wed Aug 16 2000 - ro@suse.de
- update to 5.6.0
* Tue Aug 15 2000 - ro@suse.de
- Security fix (/bin/mail+suidperl) added (from draht@suse.de)
* Fri Jul 14 2000 - kukuk@suse.de
- Add license information and group tag (Bug #3454)
* Tue Jul 11 2000 - ro@suse.de
- make perllocal.SuSE script more flexible
* Sat Apr 01 2000 - bk@suse.de
- some tests don't pass on s390 too, known.
* Fri Mar 03 2000 - schwab@suse.de
- Add support for ia64.
* Wed Jan 19 2000 - ro@suse.de
- man -> /usr/share/man ; affects all perl packages
* Tue Dec 14 1999 - kukuk@suse.de
- Fixed for SPARC
* Tue Nov 02 1999 - ro@suse.de
- do h2ph for stdarg and stddef (BUG#785)
* Tue Oct 19 1999 - ro@suse.de
- don't print error if /usr/src/linux is not owned by a package
  (BUG#215)
* Mon Sep 13 1999 - bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Fri Aug 27 1999 - ro@suse.de
- added "gnu","net" and "rpc" to directories for h2ph
* Fri Jul 09 1999 - ro@suse.de
- added "bits" to directories for h2ph (closing BUG 58)
* Thu Jul 08 1999 - ro@suse.de
- fix for perldoc
- update to 5.005_03
* Mon Mar 01 1999 - ro@suse.de
- t/lib/anydbm: removed test 12 : create empty record: invalid for db2
* Thu Jan 07 1999 - ro@suse.de
- alpha changes ; dont "make test" on alpha for now :-(
* Mon Nov 16 1998 - ro@suse.de
- update to 5.00502
- fixed manpages for h2ph, h2xs, pod2man
- use configure.gnu
- keep SuSEconfig.perl from using more time than needed
* Fri Aug 28 1998 - ro@suse.de
- updated to version perl5.004_05-MAINT_TRIAL_5
- updated filelist
- temporarily disablet test op/group.t for nobody/nogroup problem
* Wed Aug 19 1998 - ro@suse.de
- added security-patches for pstruct and perldoc
* Fri Jul 24 1998 - bs@suse.de
- enabled bincompat3
* Thu Jul 09 1998 - ro@suse.de
- added some security and glib-patches (doio.c, perl.c)
- re-added support for gdbm
* Mon Jul 06 1998 - ro@suse.de
- added rc.config.perl with variables:
  CREATE_PERLLOCAL_POD="yes"
  GENERATE_PERL_SYSTEM_INCLUDES="yes"
* Mon Jul 06 1998 - ro@suse.de
- added SuSEconfig.perl and perllocal.SuSE
  + check if kernel-sources have changed and call h2ph
  + check installed modules and add/delete entries in perllocal.pod
* Thu Jan 22 1998 - florian@suse.de
- use a fixed path as architecture name
* Tue Nov 11 1997 - florian@suse.de
- fixed file list
- update to perl 5.004_04
* Tue Oct 14 1997 - ro@suse.de
- ready for autobuild
  updated file list
* Thu Oct 09 1997 - florian@suse.de
- prepare for autobuild
* Tue May 20 1997 - florian@suse.de
- update to version 5.004
- disable hooks to csh in perl, it is not installed on all systems
* Thu Jan 02 1997 - bs@suse.de
  h2ph call in doinst.sh added.
* Thu Jan 02 1997 - florian@suse.de
  update to version 5.003
  security fix for suidperl
